#include<stdlib.h>

typedef int tipoelem;

typedef nodostruct * albero;
typedef nodostruct * nodo;

struct nodostruct{
	tipoelem valore;
	nodo padre;
	nodo primofiglio;
	nodo fratello;
};
//PROTOTIPI
albero creaalbero();
int alberovuoto(albero);
//albero insradice(albero);
nodo radice(albero);
int foglia(nodo,albero);
nodo primofiglio(nodo,albero);
int finefratelli(nodo U,albero T);
nodo succfratello(nodo U,albero T);
albero inssottoalbero(nodo U, nodo V, albero A, albero B);
albero cancsottoalbero(nodo,albero);
//OPERATORI
albero creaalbero(){
	albero T;
	T=(albero)malloc(sizeof(nodostruct));
	T->padre=NULL;
	T->primofiglio=NULL;
	T->fratello=NULL;
	return T;
}

int alberovuoto(albero T){
	return ((T->padre==NULL)&&(T->primofiglio==NULL)&&(T->fratello==NULL));
}

/*albero insradice(nodo U,albero T){
	if(alberovuoto(T)) 
	T->primofiglio=U
	return T;
} DA RIVEDERE!!!!*/

nodo radice(albero T){
	if(!alberovuoto(T)) return T->primofiglio;
}

nodo padre(nodo U, albero T){
	if((!alberovuoto(T))&&(!(U==T))) return U->padre;
}

int foglia(nodo U,albero T){
	if(!alberovuoto(T)) return ((U->primofiglio) ? 0 : 1);
}

nodo primofiglio(nodo U,albero T){
	if((!alberovuoto(T))&&(!foglia(U)) return (U->primofiglio);
}

int finefratelli(nodo U,albero T){
	if(!alberovuoto(T)) return ((U->fratello==NULL) ? 1 : 0);
}

nodo succfratello(nodo U,albero T){
	if((!alberovuoto(T))&&(!finefratelli(U)) return (U->fratello);
}

albero inssottoalbero(nodo N, nodo M, albero A, albero B){
	if((!alberovuoto(A))&&(!alberovuoto(B)){
		B->padre=N;	//aggiorno il padre del sotto albero che sto per spostare
		if(N!=M){
			B->fratello=M->fratello;	//salvo il puntatore al fratello minore
			M->fratello=B;	//aggiorno il puntatore  del fratello maggiore x farlo puntare al nuovo fratello minore
			}
		else {
			B->fratello=N->primofiglio;
			N->primofiglio=B;
			}
	}
	return A;
}		

albero cancsottoalbero(nodo U,albero T){
	if(!alberovuoto(T)) 
	
	free(U);	
}