/* Implementazione di coda tramite lista monodirezionale */

typedef int tipoelem;

typedef struct structelem * posizione;


// struttura elemento lista
struct structelem {
  tipoelem elemento;
  posizione successivo;
};


// struttura coda
struct structcoda {
  posizione testa;
  posizione fondo;
};


typedef struct structcoda * coda;

////////////////////////////////////////////////////////////

// CREACODA
coda CREACODA () {
  coda q = malloc (sizeof(struct structcoda));
  q->testa = NULL;
  q->fondo = NULL;
}

// CODAVUOTA
int CODAVUOTA ( coda Q ) {
  return  ( Q->testa == NULL ) ? 1 : 0;
}


// LEGGICODA
tipoelem LEGGICODA ( coda Q ) {
  return (Q->testa->elemento);
}


// INCODA
void INCODA ( tipoelem a, coda Q ) {
  posizione p   = malloc(sizeof(struct structelem));
  p->elemento   = a;
  p->successivo = NULL;
  if ( Q->fondo != NULL ) {
    Q->fondo->successivo = p;
  }
  if ( Q->testa == NULL ) {
    Q->testa = p;
  }
  Q->fondo = p;
}


// FUORICODA
void FUORICODA ( coda Q ) {
  posizione tmp = Q->testa;
  Q->testa = Q->testa->successivo;
  if ( Q->testa == NULL ) {
    Q->fondo == NULL;
  }
  free(tmp);
}
