#include "lista.h"

typedef lista insieme;

insieme CREAINSIEME {
  return CREALISTA();
}

void INTERSEZIONE ( insieme A, insieme B, insieme C ) {
  posizione p, q, r;
  
  C = CREAINSIEME();  
  p = PRIMOLISTA(A);
  q = PRIMOLISTA(B);
  r = PRIMOLISTA(C);
  
  while ( ! FINELISTA(p, A) && ! FINELISTA(q, B) )
  
    if ( LEGGILISTA(p, A) == LEGGILISTA(q, B) ) {
      r = SUCCLISTA(r);             // per mantenere l'ordine crescente
      INSLISTA ( LEGGILISTA(p, A), &r );
      p = SUCCLISTA(p);
      q = SUCCLISTA(q);
    } else {
      if ( LEGGILISTA(p, A) < LEGGILISTA(q, B) )
        p = SUCCLISTA(p);          // elem puntato da p non esiste in B
      else 
        q = SUCCLISTA(q);          // elem puntato da q non esiste in A
    }
}
