#define MAXLUNG 1024

typedef int tipoelem;

typedef int componente;

typedef int insieme;

struct mfset_struct { 
  int padre;
  int dimensione;
};

typedef struct mfset_struct mfset[MAXLUNG];

void CREAMFSET ( insieme A, mfset S ) {
  int i;
  
  for ( i=0; i < A; i++ ) {
    S[i].padre      = -1;
    S[i].dimensione = 1;
  }  
  
}


componente TROVA ( tipoelem x, mfset S ) { 
  if ( S[x].padre == -1 ) 
    return x;
  else 
    return TROVA( S[x].padre, S );
}    


componente TROVA_E_COMPRIMI ( tipoelem x, mfset S ) {
  if ( S[x].padre == -1 )
    return x;
  else {
    S[x].padre = TROVA( S[x].padre, S );
    return S[x].padre;
  }
} 


void FONDI (tipoelem x, tipoelem y, mfset S) {
  componente i, j;
  
  i = TROVA(x, S);
  j = TROVA(y, S);
  
  if ( i != j ) 
  
    if ( S[i].dimensione < S[j].dimensione ) {
      S[i].padre = j;
      S[j].dimensione += S[i].dimensione;
    } else {
      S[j].padre = i;
      S[i].dimensione += S[j].dimensione;
    }  
}





