#include "pile.h"

typedef pila piolo;
int ndischi=21;

void muovidisco(piolo origine, piolo destinazione);
void torredihanoi(int ndischi, piolo origine, piolo destinazione, piolo intermedio);

void muovidisco(piolo origine, piolo destinazione){
     tipoelem temp;
     temp=leggipila(origine);
     inpila(temp,destinazione);
     fuoripila(origine);
     }

void torredihanoi(int ndischi, piolo origine, piolo destinazione, piolo intermedio){
     if (ndischi==1) muovidisco(origine, destinazione);
     else{
          torredihanoi(ndischi-1,origine,intermedio,destinazione);
          muovidisco(origine,destinazione);
          torredihanoi(ndischi-1,intermedio,destinazione,origine);
          }
     }

int main()
{
  int i;                                 //numero dischi
  piolo origine,intermedio,destinazione;
  origine=creapila();
  intermedio=creapila();
  destinazione=creapila();
  for(i=ndischi;i>0;i--)inpila(i,origine);         //inizializzo il piolo con dischi di diametro decrescente dal basso
  printf("elem in cima al piolo origine : %d \n",leggipila(origine));         //stampo l'elem in cima alla pila dopo l'inizializzazione (1, il disco dal diametro + basso)
  torredihanoi(ndischi,origine,destinazione,intermedio);
  printf("elem in cima al piolo destinazione : %d \n",leggipila(destinazione));

  getchar();
  getchar();

  return 0;
}


