// ints0.h: Dynamic arrays without reference counting.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>

class ints {
public:
   ints(){p = NULL; length=0;}
   ints(int *a, int n);
   ints(const ints &r);
   ~ints(){delete[]p;}
   ints &operator=(const ints &r);
   int len()const {return length;}
private:
   int *p;
   int length;
};

