template <class T>
static void sift(T *a, int k, int n)
{  int i, j;
   T x;
   i = k; x = a[i];
   while ((j = 2 * i + 1) < n)
   {  if (j < n - 1 && a[j] < a[j+1]) j++;
      if (x >= a[j]) break;
      a[i] = a[j]; i = j;
   }
   a[i] = x;
}

template <class T>
void HeapSort(T *a, int n)
{  T x;
   for (int k=n/2-1; k>=0; k--) sift(a, k, n);
   while (--n > 0)
   {  x = a[0]; a[0] = a[n]; a[n] = x;
      sift(a, 0, n);
   }
}

