// qsrtapp: An application of the QuickSort template.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <iomanip.h>
#include "quicksrt.h"

int main()
{  double a[] = {15, 1, 20, 3, 18, 7, 4, 1, 1, 2};
   int n = sizeof(a)/sizeof(*a), i;
   cout << "Before sorting:\n";
   for (i=0; i<n; i++) 
      cout << setw(3) << a[i];
   cout << endl;
   QuickSort(a, n);
   cout << "After sorting:\n";
   for (i=0; i<n; i++) 
      cout << setw(3) << a[i];
   cout << endl;
   return 0;
}
