// olistap: An ordered list; insertion and deletion.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <ctype.h>
#include "olist.h"
typedef olist<int> Olist;
typedef elem<int> Elem;

int main()
{  Olist L;
   Elem *p;
   int x, found;
   char cmd;
   for (;;)
   {  cout << "Enter an integer, followed by I for insertion\n"
              "or by D for deletion, or enter Q to quit: ";
      if (!(cin >> x >> cmd)) break;
      cmd = toupper(cmd);
      p = L.FindPosition(x, found);
      if (cmd == 'I') L.InsertBefore(p, x); else
      if (cmd == 'D')
      {  if (found) L.Remove(p); else cout << "Not found.\n";
      }
      cout << "Contents: "; L.PrintList(); cout << endl;
   }
   return 0;
}

