// queue1.h: Template for a queue implemented as an array.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

template <class T, int max>
class queue1 {
public:
   queue1() {a = new T[max]; n = front = rear = 0;}
   ~queue1() {delete[]a;}
   void AddToRear(T x)
   {  if (n == max) throw 2;
      a[rear++] = x; n++;
      rear %= max;
   }
   int GetFromFront(T &x)
   {  if (n > 0)
      {  x = a[front++]; n--;
         front %= max;
         return 1;
      }  else return 0;
   }
private:
   int front, rear, n;
   T *a;
};

