// stack1.h: Template for a stack implemented as an array.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

template <class T, int max>
class stack1 {
public:
   stack1() {a = new T[max]; n = 0;}
   ~stack1() {delete[]a;}
   void push(T x)
   {  if (n < max) a[n++] = x;
      else throw 1;
   }
   int pop(T &x)
   {  if (n > 0) {x = a[--n]; return 1;}
      else return 0;
   }
private:
   int n;
   T *a;
};

