/* Function for binary search.
   Array a[0], a[1], ..., a[n-1] is searched for x.    
   Returned value:  0 if x <= a[0], or 
                    i, where  a[i-1] < x <= a[i], or
                    n if a[n-1] < x.

*/

int BinSearch(int x, const int *a, int n)
{  int middle, left=0, right=n-1;
   if (x <= a[left]) return 0; 
   if (x > a[right]) return n;
   while (right - left > 1)
   {  middle = (right + left)/2;
      (x <= a[middle] ? right : left) = middle; 
   }
   return right;
}
