// search.h: Header file for class search.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

class search {
public:
   search(const char *pat);
   ~search(){delete[] skip2;}
   char *find(char *text);
private:
   const char *pattern;
   int skip1[256],       // Related to bad character
       *skip2,           // Related to good suffix
       m;                // Pattern length
};

