// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 10 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// nested: A variable number of nested loops
#include <iostream.h>
#include <iomanip.h>

class loops {
public:
   loops();
   ~loops(){delete[]lower; delete[]upper; delete[]r;}
   void print();
private:
   int *lower, *upper, *r, n;
   void f(int k);
   void PrintArray();
};

loops::loops()
{  cout << "Enter n: "; cin >> n;
   lower = new int[n]; upper = new int[n]; r = new int[n];
   cout << "Enter " << n << " pairs (lower, upper):\n";
   for (int i=0; i<n; i++) cin >> lower[i] >> upper[i];
}

void loops::print()
{  cout << "Output:\n\n ";
   for (int i=0; i<n; i++) cout << "  r[" << i << "]";
   cout << endl;
   f(0);  // This call initiates the whole process.
}

void loops::f(int k)
{  if (k == n) PrintArray(); else
   for (r[k] = lower[k]; r[k] <= upper[k]; r[k]++)
      f(k + 1);
}

void loops::PrintArray()
{  for (int i=0; i<n; i++) cout << setw(6) << r[i];
   cout << endl;
}

int main()
{  loops L;
   L.print();
   return 0;
}

