#include "pile.h"

typedef pila piolo;

void muovidisco(piolo origine, piolo destinazione);
void torredihanoi(int n, piolo origine, piolo destinazione, piolo intermedio);

void muovidisco(piolo origine, piolo destinazione){
     tipoelem temp;
     temp=leggipila(origine);
     inpila(temp,destinazione);
     fuoripila(origine);
     }

void torredihanoi(int n, piolo origine, piolo destinazione, piolo intermedio){
     if (n==1) muovidisco(origine, destinazione);
     else{
          torredihanoi(n-1,origine,intermedio,destinazione);
          muovidisco(origine,destinazione);
          torredihanoi(n-1,intermedio,destinazione,origine);
          }
     }

int main()
{
  int n=5;                                 //numero dischi
  piolo origine,intermedio,destinazione;
  origine=creapila();
  intermedio=creapila();
  destinazione=creapila();
  for(;n>0;n--)inpila(n,origine);         //inizializzo il piolo con dischi di diametro decrescente dal basso
  printf("elem in cima al piolo origine: %d",leggipila(origine));         //stampo l'elem in cima alla pila dopo l'inizializzazione (1, il disco dal diametro + basso)
  torredihanoi(n,origine,destinazione,intermedio);
  printf("elem in cima al piolo origine: %d",leggipila(destinazione));

  getchar();
  getchar();

  return 0;
}


