/* implementazione di una coda tramite una lista bidirezionale */

#include "lista.h"
#include "lista-aux.h"

typedef lista coda;

lista CREACODA () {
  return CREALISTA();
}


int CODAVUOTA (coda Q) {
  return LISTAVUOTA (Q);
}


tipoelem LEGGICODA ( coda Q ) {
  return ( LEGGILISTA ( ULTIMOLISTA(Q) ) );
}


void FUORICODA ( coda Q ) {
  posizione p = ULTIMOLISTA(Q);
  CANCLISTA(&p);  
}


void INCODA ( tipoelem a, coda Q ) {
  posizione p = PRIMOLISTA(Q);
  INSLISTA(a, &p);
}

void DISTRUGGICODA ( coda Q ) {
  if ( CODAVUOTA(Q) ) {
    free(Q);
  } else {
    fprintf(stderr, "ERROR: trying to destroy a non void coda\n");
  }
}


void STAMPACODA ( coda Q ) {
  PRINTLISTA(Q);
}
 
  
