/* Realizzazione del tipo di dato insieme tramite vettore booleano */

#define N 1024

typedef int tipoelem;

typedef char * insieme;

typedef char boolean;

insieme CREAINSIEME ( ) {
  int i;
  insieme A;  
  A = (insieme) malloc (N * sizeof(boolean));
  for ( i = 0; i < N; i++ ) 
    A[i] = 0;
}


boolean INSIEMEVUOTO ( insieme A ) {
  int i         = 0;
  boolean vuoto = 1;
  while ( vuoto && ( i < N ) ) {
    vuoto = (A[i] == 0) ? 1 : 0;
    i++;
  }
  return vuoto;
}


boolean APPARTIENE ( tipoelem e, insieme A ) {
  return ( A[e] );
}


void INSERISCI ( tipoelem e, insieme A ) {
  A[e] = 1;
}


void CANCELLA ( tipoelem e, insieme A ) {
  A[e] = 0;
}


void UNIONE ( insieme A, insieme B, insieme C ) {
  int i;
  for ( i = 0; i < N; i++ )
    C[i] = A[i] || B[i];
}


void INTERSEZIONE ( insieme A, insieme B, insieme C ) {
  int i;
  for ( i = 0; i < N; i++ ) 
    C[i] = A[i] && B[i];
}


void DIFFERENZA ( insieme A, insieme B, insieme C ) {
  int i;
  for ( i = 0; i < N; i++ )
    C[i] = A[i] && ! B[i];
}


