/* implementazione di una pila tramite liste */

#include "lista.h"
#include "lista-aux.h"

typedef lista pila;

lista CREAPILA () {
  lista L;
  L = CREALISTA();
  return L;
}

int PILAVUOTA (pila P) {
  return LISTAVUOTA(P);
}

tipoelem LEGGIPILA ( pila P ) {
  return (LEGGILISTA(ULTIMOLISTA(P)));
}

void FUORIPILA ( pila P ) {
  posizione p = ULTIMOLISTA(P);
  CANCLISTA(&p);  
}

void INPILA ( tipoelem a, pila P) {
  posizione p = SUCCLISTA(ULTIMOLISTA(P));
  INSLISTA(a, &p);
}

void DISTRUGGIPILA (pila P) {
  if ( PILAVUOTA(P) ) {
    free(P);
  } else {
    fprintf(stderr, "ERROR: trying to destroy a non void pila\n"); 
  }
}

void STAMPAPILA( pila P) {
  PRINTLISTA(P);
}
