// ints0.cpp: Implementation of class ints
//    (preliminary version: no reference counting).

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include "ints0.h"

ints::ints(int *a, int n)
{  p = new int[n];
   for (int i=0; i<n; i++) p[i] = a[i];
   length = n;
}

ints::ints(const ints &r)
{  length = r.length;
   p = new int[length];
   for (int i=0; i<length; i++) p[i] = r.p[i];
}

ints &ints::operator=(const ints &r)
{  if (&r != this)
   {  delete[] p;
      length = r.length;
      p = new int[length];
      for (int i=0; i<length; i++) p[i] = r.p[i];
   }
   return *this;
}

