// swap: Demonstration of a swap template.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 1 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
struct point{float x, y;};

template <class T>
void swap(T &x, T &y)
{  T w = x; x = y; y = w;
}
int main()
{  int i = 5, j = 8;
   char *month1 = "April", *month4 = "January";
   point P = {3, 4}, Q = {8, 2};
   swap(i, j); // Two integers swapped
   swap(month1, month4); // Two pointers swapped
   swap(P, Q); // Two points swapped
   cout << "i=" << i << "  j=" << j << endl;
   cout << month1 << endl << month4 << endl;
   cout << "P: (" << P.x << ", " << P.y << ")\n";
   cout << "Q: (" << Q.x << ", " << Q.y << ")\n";
   return 0;
}
