// Quicksort; first version, two recursive calls.

template <class T>
void qsort1(T *a, int n)
{  int i = 0, j = n - 1;
   T x = a[j/2], w;
   do
   {  while (a[i] < x) i++;
      while (a[j] > x) j--;
      if (i < j) {w = a[i]; a[i] = a[j]; a[j] = w;} else
      {  if (i == j){i++; j--;}
         break;
      }
   }  while (++i <= --j);
   if (j > 0) qsort1(a, j+1);     //  a[0], ..., a[j]
   if (i < n-1) qsort1(a+i, n-i); //  a[i], ..., a[n-1]
}

