// Quicksort with limited recursion depth.

template <class T>
void q_sort(T *a, int n)
{  int i, j;
   T x, w;
   do
   {  i=0; 
      j=n-1;
      x = a[j/2];
      do
      {  while (a[i] < x) i++;
         while (a[j] > x) j--;
         if (i < j) 
         {  w = a[i]; a[i] = a[j]; a[j] = w;
         }  else
         {  if (i == j){i++; j--;}
            break;
         }
      }  while (++i <= --j);
      if (j+1 < n-i)
      {  if (j > 0) q_sort(a, j+1);
         a += i; n -= i;
      }  else
      {  if (i < n-1) q_sort(a+i, n-i);
         n = j + 1;
      }
   }  while (n > 1);
}

