// progarg: Program arguments sorted by qsort.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 3 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <stdlib.h>
#include <string.h>

int compare(const void *p, const void *q)
{  return strcmp(*(char **)p, *(char **)q);
}

int main(int argc, char *argv[])
{  qsort(argv + 1, argc - 1, sizeof(char *), compare);
   for (int i=1; i<argc; i++) cout << argv[i] << endl;
   return 0;
}
