// listap2: Virtual destructor in action.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include <string.h>
#include "linklist.h"

typedef LinkList<float> fLinkList;

class fList1: public fLinkList {
public:
   fList1(){name = new char[100]; strcpy(name, "Example");}
   ~fList1(){delete[] name;}
private:
   char *name;
};

int main()
{  fLinkList *pList;
   pList = new fList1;
   pList->append(1.1); pList->append(3.3);
   pList->PrintList();  // Output: 1.1 3.3
   delete pList;
   return 0;
}

