// simq: Simulation of a queue of persons.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "queue.h"
const int LEN=40;
struct person{char name[LEN];};
int main()
{  person x;
   queue<person> q;
   cout << "Each time, enter either a name to add it to a\n"
      "queue or a question mark to remove it from it.\n"
      "The program terminates when the queue gets empty:\n";
   for (;;)
   {  cout << "Input: "; cin.getline(x.name, LEN);
      if (x.name[0] == '?')
      {  if (q.GetFromFront(x))
         {  cout << "                     Output: "
                 << x.name << endl;
         }  else break;
      }  else q.AddToRear(x);
   }
   cout << "Empty queue.\n";
   return 0;
}

