// stackapp: Application program, demonstrating stacks.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 4 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
#include "stack1.h"

int main()
{  int k;
   float x;
   stack1<int, 10> i_st;
   stack1<float, 10> f_st;
   cout << "Enter some integers followed by a "
           "nonnumeric character:\n";
   try
   {  while (cin >> k) i_st.push(k);
   }
   catch(int i)
   {  cout << "Stack overflow\n";
   }
   f_st.push(1.2);
   f_st.push(3.4);
   cout << "1.2 and 3.4 pushed onto float stack.\n";
   cout << "Items popped from int stack:\n";
   while (i_st.pop(k)) cout << k << " ";
   cout << "\nItems popped from float stack:\n";
   while (f_st.pop(x)) cout << x << " ";
   cout << endl;
   return 0;
}

