// hash2.h: Hashing with open addressing.

// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 5 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

#include <iostream.h>
struct elem {char name[30]; unsigned num;};

class HashTable {
public:
   HashTable(unsigned len=1021);
   ~HashTable(){delete[] a;}
   void insert(const char *s, unsigned num);
   elem *find(const char *s);
private:
   unsigned hash(const char *s);
   unsigned HashIncr()const{return 1 + sum % (N - 2);}
   int h2(const char *t, unsigned &i)const;
   unsigned N, sum;
   elem *a;
};

