// Copyright(c) 1996 Leendert Ammeraal. All rights reserved.
// This program text occurs in Chapter 10 of
//
//    Ammeraal, L. (1996) Algorithms and Data Structures in C++,
//       Chichester: John Wiley.

// comb: Generation of combinations in natural order
#include <iostream.h>

class combinations {
public:
   combinations();
   ~combinations(){delete[]r;}
   void print(){cout << "Combinations:\n"; combin(1);}
private:
   int *r, n, k;
   void combin(int m);
};

combinations::combinations()
{  do
   {  cout << "Enter n and k (k not greater than n): ";
      cin >> n >> k;
   }  while (n < 0 || k < 0 || k > n);
   r = new int[k + 1];
   r[0] = 0;
}

void combinations::combin(int m)
{  if (m <= k)
   {  for (r[m] = r[m-1] + 1; r[m] <= n-k+m; r[m]++)
         combin(m + 1);
   }  else
   {  for (int i=1; i<=k; i++) cout << r[i] << " ";
      cout << endl;
   }
}

int main()
{  combinations P;
   P.print();
   return 0;
}

